--- Zend/zend.c.orig	2008-01-29 03:36:03.000000000 -0500
+++ Zend/zend.c	2008-01-29 04:20:33.000000000 -0500
@@ -1116,6 +1116,7 @@
 	zend_op_array *orig_op_array = EG(active_op_array);
 	zval **orig_retval_ptr_ptr = EG(return_value_ptr_ptr);
 	zval *local_retval=NULL;
+	int res = SUCCESS;
 
 	va_start(files, file_count);
 	for (i=0; i<file_count; i++) {
@@ -1171,17 +1172,15 @@
 			destroy_op_array(EG(active_op_array) TSRMLS_CC);
 			efree(EG(active_op_array));
 		} else if (type==ZEND_REQUIRE) {
-			va_end(files);
-			EG(active_op_array) = orig_op_array;
-			EG(return_value_ptr_ptr) = orig_retval_ptr_ptr;
-			return FAILURE;
+			res = FAILURE;
+			break;
 		}
 	}
 	va_end(files);
 	EG(active_op_array) = orig_op_array;
 	EG(return_value_ptr_ptr) = orig_retval_ptr_ptr;
 
-	return SUCCESS;
+	return res;
 }
 
 #define COMPILED_STRING_DESCRIPTION_FORMAT "%s(%d) : %s"
--- main/main.c.orig	2008-01-29 03:54:02.000000000 -0500
+++ main/main.c	2008-01-29 04:44:21.000000000 -0500
@@ -1927,7 +1927,9 @@
 #else
 	char *old_cwd;
 #endif
-	int retval = 0;
+    /* Since execution block is in a zend_try, retval will be setted to 
+     * SUCCESS only if script executes correctly. */
+	int retval = FAILURE;
 
 	EG(exit_status) = 0;
 	if (php_handle_special_queries(TSRMLS_C)) {
@@ -2001,7 +2003,7 @@
 #endif
 			zend_set_timeout(INI_INT("max_execution_time"));
 		}
-		retval = (zend_execute_scripts(ZEND_REQUIRE TSRMLS_CC, NULL, 3, prepend_file_p, primary_file, append_file_p) == SUCCESS);
+		retval = zend_execute_scripts(ZEND_REQUIRE TSRMLS_CC, NULL, 3, prepend_file_p, primary_file, append_file_p);
 
 	} zend_end_try();
 
--- sapi/apache2handler/sapi_apache2.c.orig	2008-01-29 02:40:02.000000000 -0500
+++ sapi/apache2handler/sapi_apache2.c	2008-01-29 04:48:45.000000000 -0500
@@ -627,11 +627,14 @@
 		zfd.free_filename = 0;
 		zfd.opened_path = NULL;
 
+		int res = 0;
 		if (!parent_req) {
-			php_execute_script(&zfd TSRMLS_CC);
+			res = php_execute_script(&zfd TSRMLS_CC);
 		} else {
-			zend_execute_scripts(ZEND_INCLUDE TSRMLS_CC, NULL, 1, &zfd);
+			res = zend_execute_scripts(ZEND_REQUIRE TSRMLS_CC, NULL, 1, &zfd);
 		}
+		if (res != 0)
+			return HTTP_INTERNAL_SERVER_ERROR;
 
 		apr_table_set(r->notes, "mod_php_memory_usage",
 			apr_psprintf(ctx->r->pool, "%u", zend_memory_peak_usage(1 TSRMLS_CC)));
